var express = require('express');
var router = express.Router();
var redis = require('../utils/redis');
// import model from './../model/session'
const model = require('./../model/session');
const user = require('./../model/users');


/* GET users listing. */
router.get('/', async function (req, res, next) {
    try {
        let data = await model.findByCondition({ type: 'customer', status: 1, kefu_id: req.cookies.username });
        return res.send({ code: 200, msg: '获取成功', data: data ? data : [] });
    } catch (e) {
        return res.send({ code: 400, msg: '获取失败' });
    }
});

router.get('/kefu', async (req, res, next) => {
    var kf_id = req.query.id;

    if (!kf_id) {
        return res.send({ code: 500, msg: "参数不全" });
    }
    try {
        let data = await user.findByUserName(kf_id);
        console.log(data)
        if (data) {
            return res.send({ code: 200, msg: '获取成功', data: data ? data : [] });
        }else{
            return res.send({ code: 0, msg: '当前客服不可用', data: null });
        }
    } catch (e) {
        console.error(e);
        return res.send({ code: 400, msg: '获取失败' });
    }

});

router.post('/rename', async (req, res, next) => {
    let data = req.body;
    let uid = data.uid;
    let nickname = data.newName;

    if (!uid || !nickname) {
        return res.send({ code: 500, msg: "参数不正确" });
    }
    try {
        let data = await model.update(uid,{nickname});
        return res.send({ code: 200, msg: '更新成功', data: {uid,nickname} });
    } catch (e) {
        console.error(e);
        return res.send({ code: 400, msg: '获取失败' });
    }

});

module.exports = router;
